##################################################
#Desc:   Build system for the Application
#Author: Mihrtec LLC
#Date:   2016
##################################################
#Included from Makefile
#Defines variables used in the make process to
#compile C files either to
#native asm through gcc, or web through
#emscripten
##################################################
#Environment Setup
##################################################
#Project root
PROJDIR  := ..
#Output directories for distributables
DISTDIR  := $(PROJDIR)/dist
#Build rules for each source type
include .make/buildc.mk
include .make/buildhtml.mk

#Build rules for tools
ifdef TOOLS
include .make/buildtools.mk
endif

#Set the final target, flags, and objects for app compile
APPC     := $(CC)
APPDEPS  := $(strip $(CDEPS) $(CTARG) $(APPDEPS))
APPSRC   := $(filter %$(COBJSUF),$(APPDEPS))
APPTARG  := $(CBINDIR)/$(APPNAME)$(APPSUF)
APPFLAGS := $(strip $(CXXFLAGS) $(CFLAGS) $(APPFLAGS))
APPDIRS  := $(sort $(dir $(APPTARG) $(APPDEPS)))

