##################################################
#Desc:   Missing CLib Generator
#Author: Mihrtec LLC
#Date:   2016
##################################################
#Included from buildc.make
#Defines vars for automatically downloading,
#compiling, and linking GNU-like C libraries
##################################################

#Modify the dependency generator to find the right directory for
#missing lib includes (they are in MLDIR/src/libname/libname)
CDEPSCOMMAND += $(patsubst %, | sed -e 's@ \(%\)/@$(MLSRCDIR)/\1/\1/@',$(MISSINGLIBS))

#Automake vars for building libs
AMGEN  ?= ./autogen.sh
AMCONF ?= ./configure
AMMAKE ?= make

#Notify user of libraries that are about to be built
$(info Libraries to be built in $(MLLIBDIR):)
$(info $(patsubst %,lib%.so,$(MISSINGLIBS)))
STATICLIBS := $(patsubst %,$(MLLIBDIR)/lib%.so,$(MISSINGLIBS))

#Ensure that C files depend on the creation of these static libs
CDEPS  += $(STATICLIBS)

